# $Revision: 1.48 $, $Date: 2002/03/02 12:37:06 $
#
# Conditional build:
# _without_whoson	- without WHOSON support
# _without_ldap		- without LDAP support
# _without_gdbm		- without GDBM support
#
Summary:	Secure Mailer for Extreme Performance Demands
Summary(pl):	Bezpieczny MTA dla Wymagajcych Ekstremalnej Wydajnoci
Name:		zmailer
Version:	2.99.55
Release:	3
License:	GPL
Vendor:		Matti Aarnio <mea@nic.funet.fi>
Group:		Networking/Daemons
Source0:	ftp://ftp.funet.fi/pub/unix/mail/zmailer/src/%{name}-%{version}.tar.gz
Source1:	%{name}-pl.txt
Source2:	forms-pl-0.4.tar.gz
Source3:	%{name}.logrotate
Patch0:		%{name}-config.diff
Patch1:		%{name}-acfix.patch
Patch2:		%{name}-glibc.patch
BuildRequires:	autoconf
BuildRequires:	db3-devel
BuildRequires:	ed
BuildRequires:	libwrap-devel
BuildRequires:	openssl-devel
BuildRequires:	pam-devel
%{!?_without_gdbm:BuildRequires:	gdbm-devel}
%{!?_without_whoson:BuildRequires:	whoson-devel}
%{!?_without_ldap:BuildRequires:	openldap-devel}
URL:		http://www.zmailer.org/
PreReq:		/sbin/chkconfig
%{!?_without_whoson:Requires:	whoson >= 1.08}
Requires(pre):	grep
Requires(post):	grep
Requires(post):	fileutils
Requires(post):	net-tools
Requires(post):	textutils
Requires(postun):	/usr/sbin/groupdel
Requires:	/etc/cron.d
Requires:	logrotate >= 2.4
Provides:	smtpdaemon
Obsoletes:	smtpdaemon
Obsoletes:	exim
Obsoletes:	masqmail
Obsoletes:	omta
Obsoletes:	postfix
Obsoletes:	qmail
Obsoletes:	sendmail
Obsoletes:	sendmail-cf
Obsoletes:	sendmail-doc
Obsoletes:	smail
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
This is a package that implements an internet message transfer agent
called ZMailer. It is intended for gateways or mail servers or other
large site environments that have extreme demands on the abilities of
the mailer. It was motivated by the problems of the Sendmail design in
such situations. Zmailer is one of the mailers able to deal with huge
quantities of mail and is more efficient any other mailer, qmail
included. It supports IPv6, WHOSON, SSL and TLS protocol.

%description -l pl
Ten pakiet zawiera implementacj agenta transportu wiadomoci
internetowych o nazwie ZMailer. ZMailer przeznaczony jest dla bramek,
serwerw poczty lub innych rodowisk wymagajcych niezwykych
moliwoci od mailera. Motywacj dla ZMailera byy problemy z
Sendmailem w trudnych sytuacjach. ZMailer jest jednym z tych mailerw,
ktre potrafi da sobie rad z ogromn iloci poczty. Ponadto
ZMailer jest bardziej wydajny od innych mailerw wczajc w to
qmaila. Kolejn zalet jest wsparcie dla protokou IPv6, WHOSON, SSL
oraz TLS.

%package devel
Summary:	Static library and header file for zmailer
Summary(pl):	Plik nagwkowy i biblioteka statyczna dla zmailera
Group:		Development/Libraries
Requires:	%{name} = %{version}

%description devel
This is ZMailer's development package. It includes static library and
header file.

%description devel -l pl
To jest pakiet dla developerw. Zawiera plik nagwkowy i bibliotek
statyczn ZMailera.

%prep
%setup -q -n %{name}-%{version} -a2
%patch0 -p1
%patch1 -p1
%patch2 -p1

%build
autoconf
%configure \
	--with-zconfig=%{_sysconfdir}/mail/zmailer.conf \
	--with-postoffice=/var/spool/postoffice \
	--with-rmailpath=%{_bindir}/rmail \
	--with-nntpserver=news \
	--with-system-malloc \
	--with-mailshare=%{_sysconfdir}/mail \
	--with-mailbin=%{_libdir}/zmailer \
	--with-mailvar=%{_sysconfdir}/mail \
	--with-ta-mmap \
	%{!?_without_whoson:--with-whoson} \
	%{!?_without_ldap:--with-ldap-prefix} \
	--with-openssl-prexix=%{_prefix} \
	--with-tcp-wrappers \
	--with-ipv6 \
	--with-mailbox=/var/mail
#	--with-yp \
#	--with-yp-lib='-lyp'
#	--prefix=%{_libdir}/zmailer \
#	--with-zconfig=no

%{__make} COPTS="%{rpmcflags} -w" all

%install
rm -rf $RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{_mandir}/man{1,3,5,8} \
	$RPM_BUILD_ROOT%{_sysconfdir}/{cron.d,logrotate.d,rc.d/init.d} \
	$RPM_BUILD_ROOT/{var/mail,usr/sbin} \
	$RPM_BUILD_ROOT/var/log/archiv/mail

# Install main files
%{__make} install \
	prefix=$RPM_BUILD_ROOT \
	MAILVAR=$RPM_BUILD_ROOT%{_sysconfdir}/mail \
	MAILSHARE=$RPM_BUILD_ROOT%{_sysconfdir}/mail \
	libdir=$RPM_BUILD_ROOT%{_libdir} \
	includedir=$RPM_BUILD_ROOT%{_includedir}

install	contrib/zmailcheck	$RPM_BUILD_ROOT%{_libdir}/zmailer/zmailcheck
install	utils/zmailer.init.sh	$RPM_BUILD_ROOT/etc/rc.d/init.d/zmailer

> $RPM_BUILD_ROOT%{_sysconfdir}/mail/mailname

# Few symlinks
ln -fs zmailer/sendmail			$RPM_BUILD_ROOT%{_libdir}/sendmail
ln -fs ../lib/zmailer/vacation.sh	$RPM_BUILD_ROOT%{_bindir}/vacation
ln -fs ../lib/zmailer/mailq		$RPM_BUILD_ROOT%{_bindir}/mailq
ln -fs ../lib/zmailer/rmail		$RPM_BUILD_ROOT%{_bindir}/rmail
ln -fs ../lib/zmailer/newaliases	$RPM_BUILD_ROOT%{_bindir}/newaliases
ln -fs ../lib/zmailer/zmailer		$RPM_BUILD_ROOT%{_sbindir}/zmailer
ln -fs ../lib/zmailer/sendmail		$RPM_BUILD_ROOT%{_sbindir}/sendmail

# Install manual pages
%{__make} -C man S=../man MANDIR=$RPM_BUILD_ROOT%{_mandir} install

# To avoid conflict with INN
mv -f $RPM_BUILD_ROOT%{_mandir}/man8/sm.8 $RPM_BUILD_ROOT%{_mandir}/man8/sm-zmailer.8

(
# Install Polish/English forms
cd forms*
cp -f forms/* $RPM_BUILD_ROOT%{_sysconfdir}/mail/forms/proto
install vacation.msg $RPM_BUILD_ROOT%{_sysconfdir}/mail

# Install proto files
cd $RPM_BUILD_ROOT%{_sysconfdir}/mail/proto
for x in *; do cp -f $x ..; done
cd $RPM_BUILD_ROOT%{_sysconfdir}/mail/forms/proto
for x in *; do cp -f $x ..; done
cd $RPM_BUILD_ROOT%{_sysconfdir}/mail/db/proto
for x in *; do cp -f $x ..; done
cd $RPM_BUILD_ROOT%{_sysconfdir}/mail/cf/proto
for x in *; do cp -f $x ..; done
cd $RPM_BUILD_ROOT%{_sysconfdir}/mail
cp -f ./cf/SMTP+UUCP.cf router.cf
)

# Aliases
> $RPM_BUILD_ROOT%{_sysconfdir}/mail/aliases

# Remove unnecesary proto and bak files
rm -rf `find $RPM_BUILD_ROOT -name proto`
rm -rf `find $RPM_BUILD_ROOT -name bak`

# Install another files
cat << EOF > $RPM_BUILD_ROOT/etc/cron.d/zmailer
# Resubmit deferred messages
28 */1 * * *		root	!%{_libdir}/zmailer/zmailer resubmit >/dev/null
# Cleanout public and postman directories
7 4 * * *		root	!%{_libdir}/zmailer/zmailer cleanup >/dev/null
# Check if services still work
11 6,12,18,0 * * *	root	!%{_libdir}/zmailer/zmailcheck
EOF

install %{SOURCE3} $RPM_BUILD_ROOT/etc/logrotate.d/zmailer

# postoffice tree (as created by proto/post-install.sh):
install -d $RPM_BUILD_ROOT/var/spool/postoffice/{deferred,freezer,postman,public}
for f1 in A B C D E F G H I J K L M N O P Q R S T U V W X Y Z ; do
	install -d $RPM_BUILD_ROOT/var/spool/postoffice/{TLSsrvrcache,TLSclntcache,router}/$f1
	for f2 in A B C D E F G H I J K L M N O P Q R S T U V W X Y Z ; do
		install -d $RPM_BUILD_ROOT/var/spool/postoffice/{queue,transport}/$f1/$f2
	done
done

cp -f %{SOURCE1} .

gzip -9nf ChangeLog Overview README* TODO doc/guides/* doc/toplevel-domains \
	doc/manual/FAQ doc/design/zmog.ps zmailer-pl.txt

%clean
rm -rf $RPM_BUILD_ROOT

%post
umask 022
/sbin/chkconfig --add zmailer

if [ -x /bin/hostname ]; then
	hostname --fqdn >/etc/mail/mailname
fi

if [ -f /etc/mail/router.fc ]; then
	rm -f /etc/mail/router.fc
fi

# Gymnastics to convice zmailer to use /etc/mail/aliases
# or provide /etc/mail/aliases it if not found.
if [ ! -L /etc/mail/db/aliases ]; then
	if [ -f /etc/mail/aliases ]; then
		echo "Generating Symlink to use /etc/mail/aliases for aliasing"
		rm -f /etc/mail/db/aliases || echo "Dziwnie pusto w (Strange nothing at) /etc/mail/db/aliases. Ale nie martw si ... (But don't worry..)"
	else
		echo "Installing new /etc/mail/aliases from zmailer sample"
		mv -f /etc/mail/db/aliases /etc/aliases
	fi
	ln -sf ../aliases /etc/mail/db/aliases
fi

# Scan for Mandatory entries in /etc/aliases
# postoffice MAILER-DAEMON postmast nobody and other users
# otherwise bad things (tm) result.

if ! grep -q "^hostmaster:" /etc/mail/aliases; then
	echo "Adding Entry for hostmaster in /etc/mail/aliases"
	echo "hostmaster:	root" >>/etc/mail/aliases
fi

for i in postmaster postoffice MAILER-DAEMON postmast nobody webmaster administrator \
ftpmaster newsmaster w3cache squid news proxy abuse ircd; do
	if ! grep -q "^$i:" /etc/mail/aliases; then
		echo "Adding Entry for $i in /etc/mail/aliases"
		echo "$i:	hostmaster" >>/etc/mail/aliases
	fi
done

# localnames
for x in `hostname --fqdn` `hostname --domain` `hostname --yp`; do
	if [ -n $x ] && ! grep -q ^$x /etc/mail/db/localnames; then
		echo "$x		`hostname --fqdn`|"
	fi
done | tr -d '\n' | tr -s '|' '\n' | sort >> /etc/mail/db/localnames

# Rebuild databases
%{_libdir}/zmailer/zmailer newdb
%{_libdir}/zmailer/policy-builder.sh -n

%preun
if [ -e /var/lock/subsys/zmailer ]; then
	/etc/rc.d/init.d/zmailer stop || :
fi

rm -f /var/spool/postoffice/.pid.*

if [ "$1" = "0" ]; then
	/sbin/chkconfig --del zmailer
	rm -f /var/log/mail/*
fi

%pre
#%{_sbindir}/groupadd -f -g 47 zmailer

if ! grep -q "^zmailer:" /etc/group; then
	echo "zmailer::47:root,petidomo,uucp,daemon,news" >>/etc/group
fi

%postun
if [ "$1" = "0" ]; then
	%{_sbindir}/groupdel zmailer 2> /dev/null
fi

%files
%defattr(644,root,root,755)
%doc *.gz doc/*.gz doc/guides doc/manual/*.gz doc/design/*.gz
%doc utils/usenet/usenet.sh utils/mail2news utils/mailgateway
%dir %{_sysconfdir}/mail
%config %{_sysconfdir}/mail/cf
%config %{_sysconfdir}/mail/forms
%config %{_sysconfdir}/mail/fqlists

%defattr(644,root,root,3755)
%config %{_sysconfdir}/mail/db

%defattr(644,root,root,2755)
%config %{_sysconfdir}/mail/lists

%defattr(644,root,root,755)
%attr(644,root,root) %config %{_sysconfdir}/mail/*.*
%attr(644,root,root) %{_sysconfdir}/mail/mailname
%attr(644,root,root) %config(noreplace) %{_sysconfdir}/mail/aliases

%attr(640,root,root) /etc/logrotate.d/zmailer
%attr(640,root,root) /etc/cron.d/zmailer

%attr(754,root,root) /etc/rc.d/init.d/zmailer

%attr(755,root,root) %{_bindir}/*
%attr(755,root,root) %{_sbindir}/*
%attr(755,root,root) %{_libdir}/sendmail
%attr(755,root,root) %{_libdir}/zmailer

%{_mandir}/man[158]/*
%attr(0755,root,root) %dir /var/spool/postoffice
%attr(0750,root,root) %dir /var/spool/postoffice/deferred
%attr(0750,root,root) %dir /var/spool/postoffice/freezer
%attr(0750,root,root) %dir /var/spool/postoffice/postman
%attr(0750,root,root) %dir /var/spool/postoffice/queue
%attr(1777,root,root) %dir /var/spool/postoffice/public
%attr(1777,root,root) %dir /var/spool/postoffice/router
%attr(0755,root,root) %dir /var/spool/postoffice/transport
%attr(0755,root,root) %dir /var/spool/postoffice/transport/*
%attr(0755,root,root) %dir /var/spool/postoffice/transport/*/*
%attr(0755,root,root) %dir /var/spool/postoffice/queue/*
%attr(0755,root,root) %dir /var/spool/postoffice/queue/*/*
%attr(0700,root,root) %dir /var/spool/postoffice/TLSsrvrcache
%attr(0700,root,root) %dir /var/spool/postoffice/TLSsrvrcache/*
%attr(0700,root,root) %dir /var/spool/postoffice/TLSclntcache
%attr(0700,root,root) %dir /var/spool/postoffice/TLSclntcache/*
%attr(750,root,root) %dir /var/log/mail
%attr(750,root,root) %dir /var/log/archiv/mail

%files devel
%defattr(644,root,root,755)

%{_libdir}/libzmailer.a
%{_includedir}/zmailer.h

%{_mandir}/man3/*

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld.org.pl>
All persons listed below can be reached at <cvs_login>@pld.org.pl

$Log: zmailer.spec,v $
Revision 1.48  2002/03/02 12:37:06  kloczek
- cosmetics.

Revision 1.47  2002/02/22 23:30:12  kloczek
- removed all Group fields translations (oure rpm now can handle translating
  Group field using gettext).

Revision 1.46  2002/02/18 16:21:09  gotar
- (postun) flag for Requires: groupdel.

Revision 1.45  2002/02/18 12:06:47  gotar
- removed PreReq %{_sbindir}/groupadd,
- PreReq: %{_sbindir}/groupdel -> Requires: /usr/sbin/groupdel,
- Requires(pre): grep,
- Requires(post): grep, fileutils, net-tools, textutils,
- Obsoletes: masqmail, omta,
- release 3.

Revision 1.44  2002/01/18 02:15:48  kloczek
perl -pi -e "s/pld-list\@pld.org.pl/feedback\@pld.org.pl/"

Revision 1.43  2001/12/07 20:49:49  grando
- added bcond for gdbm-devel

Revision 1.42  2001/12/06 20:57:29  juandon
- added ed to BuildRequires.
- Release: 2.

Revision 1.41  2001/10/11 14:55:58  qboosh
- BuildRequires: autoconf

Revision 1.40  2001/09/18 10:27:02  qboosh
- BuildRequires: pam-devel, db3-devel, gdbm-devel

Revision 1.39  2001/09/17 10:56:32  qboosh
- 2.99.55, updated config.diff, removed libwrap patch
- added glibc and acfix patches
- added bconds for ldap and whoson
- builds but not tested...

Revision 1.38  2001/07/26 05:42:27  saq
- reverting last change: removing new macros from %p{re,ost}{,un}

Revision 1.36  2001/04/30 16:05:33  kloczek
- added using %%{rpmcflags} macro.

Revision 1.35  2001/02/19 23:56:57  kloczek
- release 2: make spec %%{debug} ready.

Revision 1.34  2000/11/09 14:02:51  kloczek
- start update to 2.99.54 (patches must be updated),
- added other curretly avalaible MTA to Obsoletes list,
- use new rpm automation.

Revision 1.33  2000/09/11 12:04:08  mis
- removed FHS dir /var/mail

Revision 1.32  2000/09/01 19:57:37  kloczek
- adapterized.

Revision 1.31  2000/09/01 13:56:36  baggins
- release 2
- fixed logrotate config

Revision 1.30  2000/08/29 14:16:01  baggins
- release 2
- removed openssl patch (obsoleted)
- compile with SSL and TCP wrappers

Revision 1.29  2000/07/19 16:05:25  mkochano
- Added Obsoletes: exim.

Revision 1.28  2000/06/09 07:24:25  kloczek
- added using %%{__make} macro.

Revision 1.27  2000/05/21 16:53:31  kloczek
- spec adapterized.

Revision 1.26  2000/04/17 06:51:03  kloczek
- spec adapteized.

Revision 1.25  2000/04/15 17:55:37  mis
- typo

Revision 1.24  2000/04/01 11:16:03  zagrodzki
- changed all BuildRoot definitons
- removed all applnkdir defs
- changed some prereqs/requires
- removed duplicate empty lines

Revision 1.23  2000/03/28 16:55:27  baggins
- translated kloczkish into english

Revision 1.22  1999/12/13 21:38:06  alchemyx
- ripped logrotate out of spec

Revision 1.21  1999/11/21 22:10:29  waszi
- small fixes

Revision 1.20  1999/11/12 00:58:43  kura

- changed Group to Networking/Daemons

Revision 1.19  1999/10/10 10:12:34  waszi
- Conflicts: -> Obsoletes:

Revision 1.18  1999/07/26 09:34:47  misiek
auto zmailer.spec actualization

Revision 1.21  1999/07/26 09:26:33  misiek
- added missing translations

Revision 1.20  1999/07/21 11:46:38  misiek
adding zmailer group + umask 022 in post

Revision 1.19  1999/07/20 12:48:12  wiget
- switch to rpm 3.0.2

Revision 1.18  1999/07/19 21:58:13  kloczek
- release 1.0,
- removed "Requires: smtpdaemon",
- removed Conflicts with sendmail, qmail, postfix, exim, smail and added
with smtpdaemon,
- some small cleanups.

Revision 1.17  1999/07/19 13:53:43  misiek
added missing BuildPrereq:

Revision 1.16  1999/07/19 13:52:32  misiek
official 2.99.51 version !

Revision 1.15  1999/07/15 15:39:06  misiek
pre3

Revision 1.14  1999/07/12 23:06:29  kloczek
- added using CVS keywords in %changelog (for automating them).

Revision 1.11  1999/07/05 12:18:40  misiek
update to 2.99.51-pre1

* Thu May 20 1999 Arkadiusz Mikiewicz <misiek@pld.org.pl>
  [2.99.50s18-1d]
- new version
- corrected spec file (ready for rpm 3.x)

* Thu Feb 10 1999 Micha Kuratczyk <kurkens@polbox.com>
  [2.99.50s11-4d]
- sloted BuildRoot into PLD standard
- "Conflicts: smtpdaemon" instead a lot of conflicts
- cosmetic changes

* Tue Jan 19 1999 Arkadiusz Mikiewicz <misiek@misiek.eu.org>
[2.99.50s11-3d]
- compile with WHOSON support
- now it's using fsync()

* Sat Jan 16 1999 Arkadiusz Mikiewicz <misiek@misiek.eu.org>
[2.99.50s11-2d]
- moved /etc/zmailer to /etc/mail
- moved /etc/{aliases,mailname} to /etc/mail/{aliases,mailname}
- spec completly rewrited

* Fri Nov 27 1998 Arkadiusz Mikiewicz <misiek@misiek.eu.org>
[2.99.50-s11-1d]
- new forms-pl-0.3,
- still as 1d,
- changed Requires hc-cron to /etc/crontab.d (few cron daemons
  support it).
By Wojtek Slusarczyk <wojtek@shadow.eu.org>
- compressed mail pages.

* Thu Nov 26 1998 Arkadiusz Mikiewicz <misiek@misiek.eu.org>
[2.99.50-s11-1d]
- added forms-pl-0.2 (Polish/English forms).

* Wed Nov 25 1998 Arkadiusz Mikiewicz <misiek@misiek.eu.org>
- now using modified router.cf

* Tue Nov 24 1998 Arkadiusz Mikiewicz <misiek@misiek.eu.org>
- updated to s11
- few changes

* Wed Nov 11 1998 Arkadiusz Mikiewicz <misiek@misiek.eu.org>
- merged %SOURCE1 and %SOURCE2 into one file
- corrected mode on /var/spool/mail
- added few pl translations
- obsoletes replaced by conflicts
- added Group(pl)
- added smail and vmailer to conflicts
- changed mode to 600 on /etc/crontab.d/zmailer

* Mon Oct 12 1998 Arkadiusz Mikiewicz <misiek@zsz2.starachowice.pl>
[2.99.50s10-1d]
- new upstream release
- compiled with ipv6 support
- added /etc/crontab.d entry
- added hc-cron to requires
- added Polish documentation
- added alfa-glibc patch
- modified logrotate config

* Sun Sep 27 1998 Arkadiusz Mikiewicz <misiek@misiek.eu.org>
- added -p to cp crontab file
- modified times in crontab file
- some fixes to manual.sgml
- added vacation to %{_bindir}
- added more restrictive files and directories modes
- added logorotate rules
- added striping
- modified Summary
- added auto stopping ZMailer before removing package
- added auto removing pid files
- added development package (but what for ? ;)

* Sat Sep 26 1998 Arkadiusz Mikiewicz <misiek@misiek.eu.org>
- added automatic removing Zmailer's cron jobs
- added $RPM_OPT_FLAGS to make

* Fri Sep 25 1998 Arkadiusz Mikiewicz <misiek@misiek.eu.org>
- Initial rpm release
